# -*- coding: euc-kr -*-
"""
YahooDict.py by ddt<ddt@mirstyle.org>
license: GPL
"""
import urllib
import re

from DictResult import DictResult
from Commons import getSortedList, ConnectException

replace_list = ((re.compile("rgb\(00,80,00\)", re.I),'#008000'),
                (re.compile(r"\n"),""),
                (re.compile("<br>"),"\n"),
                (re.compile("</?table[^>]*>"), ""),
                (re.compile("</?td[^>]*>"), ""),
                (re.compile("</?tr[^>]*>"), ""),
                (re.compile("</?span[^>]*>"), ""),
                (re.compile("</?p[^>]*>"), "\n"),
                (re.compile("(&#[0-9]{1,5});?"), "\g<1>;")
               )

class YahooDict:
    def __init__(self):
        pass
    
    def search(self, word, lang="en"):
        if lang == "en":
            url = "http://kr.engdic.yahoo.com/search/engdic?p="
        elif lang == "ko":
            url = "http://kr.kordic.yahoo.com/search/kordic?p="
        try:
            data = urllib.urlopen(url+urllib.quote(word)).read()
        except:
            raise ConnectException()

        result = DictResult()
        # stupid search -,.-;;
        if lang == "en":
            start = data.find(" ")
            end = data.find("ܾǮ ")
            p = re.compile("("+word.split()[0]+" [0-9]+)")
            sameWords = p.findall(data)
            if sameWords:
                result.setSameWords(getSortedList(sameWords))
        elif lang == "ko":
            start = data.find("ܾ ")
            end = data.find("ܾ ˻  ")
        data = data[start:end]
        s = data.find("<t")
        e = data.find("<!")
        data = data[s:e]
        for p, s in replace_list:
            data = p.sub(s, data)
        result.setResult(data)
        return result
